import { BuilderInstance } from './types';
export declare const builderCreators: {
    aql: (args: {
        expression: string;
    }) => BuilderInstance;
    aqlDocument: (args: {
        collection: string;
        key: string;
        filter?: string | undefined;
        sort?: AqlSortInput | undefined;
        limit: AqlLimitInput;
    }) => BuilderInstance;
    aqlEdge: (args: {
        direction: AqlEdgeDirection;
        collection: string;
        options?: AqlTraverseOptionsInput | undefined;
    }) => BuilderInstance;
    aqlNode: (args: {
        edgeCollection: string;
        direction: AqlEdgeDirection;
        filter?: string | undefined;
        sort?: AqlSortInput | undefined;
        limit?: AqlLimitInput | undefined;
        options?: AqlTraverseOptionsInput | undefined;
    }) => BuilderInstance;
    aqlEdgeNode: () => BuilderInstance;
    aqlSubquery: (args: {
        query: string;
        return?: string | undefined;
    }) => BuilderInstance;
    aqlKey: () => BuilderInstance;
    aqlRelayConnection: (args: {
        edgeCollection?: string | undefined;
        edgeDirection?: "INBOUND" | "OUTBOUND" | undefined;
        documentCollection?: string | undefined;
        cursorExpression?: string | undefined;
        source?: string | undefined;
        filter?: string | undefined;
        sortOrder?: "ASC" | "DESC" | undefined;
    }) => BuilderInstance;
    aqlRelayEdges: () => BuilderInstance;
    aqlRelayPageInfo: () => BuilderInstance;
    aqlRelayNode: () => BuilderInstance;
};
export declare type AqlEdgeDirection = 'INBOUND' | 'OUTBOUND';
export declare type AqlSortOrder = 'ASC' | 'DESC';
export declare type AqlSortInput = {
    property: string;
    order?: AqlSortOrder;
    sortOn?: string;
};
export declare type AqlLimitInput = {
    count: string;
    skip?: string;
};
export declare type AqlTraverseOptionsInput = {
    bfs?: boolean;
    uniqueVertices?: string;
    uniqueEdges?: string;
};
