import { Database } from 'arangojs';
import { GraphQLResolveInfo } from 'graphql';
import { AqlQuery } from 'arangojs/lib/cjs/aql-query';
export declare type DBQuery = {
    returnsList: boolean;
    fieldNames: string[];
    fieldQueries: {
        [name: string]: DBQuery;
    };
    paramNames: string[];
    params: DBQueryParams;
    builder: BuilderInstance;
};
export declare type DBQueryParams = {
    args?: {
        [name: string]: any;
    };
};
export declare type QueryFieldMap = {
    [path: string]: DBQuery;
};
export declare type Builder = {
    name: string;
    build: (args: {
        fieldName: string;
        directiveArgs: {
            [name: string]: any;
        };
        fieldArgs: {
            [name: string]: any;
        };
        returnsList: boolean;
        parentName: string;
        children: () => string;
    }) => string;
};
export declare type BuilderInstance = {
    builder: Builder;
    directiveArgs: {
        [name: string]: any;
    };
};
export declare type LibraryOptions = {
    builders?: {
        [name: string]: Builder;
    };
    argumentResolvers?: {
        [pathPart: string]: any;
    };
    contextKey?: string;
    db?: Database;
    contextDbKey?: string;
};
export declare type AqlResolver = {
    (parent: any, args: any, context: any, info: GraphQLResolveInfo): Promise<any>;
    runCustomQuery: (args: {
        query?: AqlQuery;
        queryBuilder?: BuilderInstance;
        info: GraphQLResolveInfo;
        parent: any;
        args: any;
        context: any;
    }) => Promise<any>;
};
